module FrontEnd.Constants
( makeConstants
) where

import Data.Monoid
import Plan
import qualified Util.UniqMap as UniqMap
import TyCon
import TysWiredIn
import Util.UniqMap (UniqMap)
import GHC
import Util.GHC
import HscTypes
import PrelNames
import Type

makeConstants :: [Int] -> [Char] -> [Float] -> [Double] -> [Integer] -> Ghc (UniqMap TyCon [Constant])
makeConstants ints chars floats doubles integers = do
  ATyCon integerTyCon <- lookupThing integerTyConName
  let integerTy = mkTyConTy integerTyCon
  return $ mconcat [ mk ints  IntConstant  intTyCon
                   , mk chars CharConstant charTyCon
                   , mk floats FloatConstant floatTyCon
                   , mk doubles DoubleConstant doubleTyCon
                   , mk integers (flip IntegerConstant integerTy) integerTyCon
                   ]
  where
    mk :: [a] -> (a -> Constant) -> TyCon -> UniqMap TyCon [Constant]
    mk as mkC tc = UniqMap.singleton tc (map mkC as)
