{-# LANGUAGE PatternGuards #-}
{-# LANGUAGE TemplateHaskell #-}
{- I WANT Data.Record.Label
 -
 - Design & Interface inspired by fclabels by
 - Sebastiaan Visser, Erik Hesselink, Chris Eidhof, Sjoerd Visscher.
 - http://hackage.haskell.org/package/fclabels
 -
 -}
module Util.FCLabels.TH(mkLabels) where

import Data.Char
import Language.Haskell.TH.Syntax
import Control.Applicative
import Control.Monad

mkLabels :: [Name] -> Q [Dec]
mkLabels names = concat <$> mapM mkLabels' names

mkLabels' :: Name -> Q [Dec]
mkLabels' name = processInfo <$> reify name

processInfo :: Info -> [Dec]
processInfo (TyConI (DataD ctx name vars cs _)) = do
  RecC _ labels <- cs
  label <- labels
  mkLabel tyFrom label
  where
    tyFrom = do guard (null ctx)
                guard (null vars)
                return (ConT name)

processInfo x = error (show x)

-- As with the original FCLabels, _ ==> removed, otherwise l ++ toUpper
mkLabel :: Maybe Type -> VarStrictType -> [Dec]
mkLabel mTyFrom (name, _, ty)
  | Just tyFrom <- mTyFrom
  = [ mkBody name
    , SigD n (mkTy tyFrom ty)
    ]
  | otherwise 
  = [ mkBody name
    ]
  where
    n = mkName $ case nameBase name of
                  ('_' : c : rest) -> toLower c : rest
                  (f : rest)       -> 'l' : toUpper f : rest
                  _                -> ""

    mkBody name = 
      FunD n [ Clause [] 
                    (NormalB ((VarE (mkName "label")) `AppE` 
                              (VarE name) `AppE`
                              (LamE [VarP (mkName "b"), VarP (mkName "a")] -- setter
                                    (RecUpdE (VarE (mkName "a")) [(name, VarE (mkName "b"))]))
                             )
                    ) 
                    []
             ]
    mkTy tyFrom tyTo = (AppT (AppT (ConT (mkName ":->")) tyFrom) tyTo)
