module Tests where

import Test

tests :: [Test]
tests = [cached1, cached2, noRepeatExecutions, repeatExecutions]

cached1 :: Test
cached1 
  = test { modu = "Cached1"
         , preOptions = ["--trace", "-d", "--ai-test", "--depth=12"]
         }

cached2 :: Test
cached2
  = test { modu = "Cached2"
         , preOptions = ["--trace", "-d", "--ai-test", "--depth=8"]
         }


noRepeatExecutions :: Test
noRepeatExecutions = test { modu       = "NoRepeatExecutions"
                          , preOptions = ["-d", "--trace", "--depth=8", "--fifo-cache=1000"]
                          }

repeatExecutions :: Test
repeatExecutions = test { modu = "RepeatExecutions"
                        , preOptions = ["-d", "--trace", "--depth=8", "--no-cache"]
                        }
