module SafeList
( SafeList
, mkList
, safeHead
, safeTail
, listToSafeList
, safeListToList
) where

newtype SafeList a = SafeList [a]
  {- user invariant, [a] always has at least 1 element -}

mkList :: a -> SafeList a
mkList x = (SafeList [x])

safeHead :: SafeList a -> a
safeHead (SafeList xs) = head xs

safeTail :: SafeList a -> [a]
safeTail (SafeList xs) = tail xs

listToSafeList :: [a] -> Maybe (SafeList a)
listToSafeList [] = Nothing
listToSafeList xs = Just (SafeList xs)

safeListToList :: SafeList a -> [a]
safeListToList (SafeList xs) = xs
