{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
module ConsolePlayer
 ( mkConsolePlayer
 ) where

import qualified Data.Set as Set
import Data.Set (Set)
import Data.List
import Board
import Player
import Control.Monad.Trans
import Control.Monad

data ConsolePlayer = CP

mkConsolePlayer :: ConsolePlayer
mkConsolePlayer = CP

instance MonadIO m => Player m ConsolePlayer where
  getMove b cp = liftIO $ do
    putStrLn $ "Where do you want to move?"

    let aps = Set.toAscList $ availablePositions b

    putStrLn $ (concat . intersperse " | " . map show $ aps ) ++ ":"
    
    position <- readOneOf (availablePositions b)

    return (position, cp)

readOneOf :: Set Position -> IO Position
readOneOf aps = do  
  (do 
    pos <- readLn 
    unless (pos `Set.member` aps) $ fail "Invalid input!"
    return pos
   ) `catch` (\e -> do
    putStrLn $ "Failed with " ++ show e ++ " - please try again!"
    readOneOf aps
   ) 
