{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE GADTs #-}
module Player
( Player(getMove)
, constantPlayer
, EPlayer(..)
) where

import qualified Data.Set as Set
import Board
import Control.Arrow
import Control.Applicative
import Control.Monad

class (Monad m) => Player m a where
  getMove :: Board -> a -> m (Position, a)

data ConstantPlayer = CP

constantPlayer :: ConstantPlayer
constantPlayer = CP

instance (Monad m) => Player m (ConstantPlayer) where
  getMove b cp = return (Set.findMin $ availablePositions b, cp)

data EPlayer m where
  EPlayer :: (Player m a) => a -> EPlayer m

instance (Monad m) => Player m (EPlayer m) where
  getMove board (EPlayer p) = second EPlayer `liftM` getMove board p
