{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE TemplateHaskell #-}
module IdDB.IdDBTest where

import Test.HUnit ((~:))
import IdDB.IdDBSampleModule
import IdDB.IdDBSampleImportedModule
import IdDB.IdDBTestLib

colour     = [t|Colour|]
weather    = [t|Weather|]
holiday    = [t|Holiday|]
partial    = [t|Partial|]
unit       = [t|()|]
listColour = [t|[Colour]|]

test 0 = with ['needsAColour] $ do
          colour `is` ['Red, 'Green, 'Blue]
          weather `isn't` there
          unit `is` ['()]
          
test 1 = with ['needsSomeWeather] $ do
          colour `isn't` there
          weather `is` ['rain, 'shine]
          unit `is` ['()]

test 2 = with ['needsColourfulWeather] $ do
          weather `is` ['rain, 'shine]
          colour  `is` ['Red, 'Green, 'Blue]
          unit `is` ['()]
          holiday `isn't` there

test 3 = with ['needsAHoliday] $ do
          holiday `is` ['chooseHoliday]
          colour `isn't` there
          weather `is` ['rain, 'shine]

test 4 = with ['iLikesABitOfThatIDo] $ do
          partial `is` ['NowYouSeeMe, 'hiddenPartial]

test 5 = with ['fastColourBoat] $ do
          colour `is` ['Red, 'Green, 'Blue]
          [t| Boat Colour |] `is` ('embark ::: [t|Colour -> Boat Colour|])

test 6 = with ['fastColourRaft] $ do
          colour `is` ['Red, 'Green, 'Blue]
          [t| Raft Colour |] `is` [ 'Wood  ::: [t| Colour -> Raft Colour|]
                                  , 'Metal ::: [t| Colour -> Raft Colour|]
                                  ]

test 7 = with ['lotsOfColours] $ do
          colour `is` ['Red, 'Green, 'Blue]
          listColour `is` [ '(:)  ::: [t| Colour -> [Colour] -> [Colour] |]
                          , '[]   ::: [t| [Colour] |]
                          ]

test 8 = with ['curriedColourHoliday] $ do
          colour `is` ['Red, 'Green, 'Blue]
          holiday `is` ['chooseHoliday]
          weather `is` ['rain, 'shine]
          [t| (Colour, Holiday) |] `is` [ '(,) ::: [t| Colour -> Holiday -> (Colour, Holiday)|]]

test 9 = with ['likesBools] $ do
          [t|Bool|] `is` ['True, 'False]

test 10 = with ['needsATypeClass1] $ do
            [t| TypeClassed |] `is` [ 'getTC ] -- TODO actually test this somehow ...
            colour `is` ['Red, 'Green, 'Blue]

test 11 = with ['needsATypeClass2] $ do
            [t| TypeClassed2 |] `is` [ 'getTC2a , 'getTC2b ]
            colour `is` ['Red, 'Green, 'Blue]

  
          
test 12 = with ['usesATypeClass] $ do
            colour `is` ['Red, 'Green, 'Blue]
            [t| TypeClassed |] `is` [ 'getTC ::: [t| Colour -> TypeClassed |] ]

test 13 = with ['needsAnyMaybe] $ do
            [t| forall a.  Maybe a|] `is` [ 'Nothing ::: [t| forall a . Maybe a |]
                                          , 'Just    ::: [t| forall a . a -> Maybe a |]
                                          ]

test _ = notWrittenYet

tests = "IdDBTest" ~: buildTests test

