module Plan.ExperimentMapTestLib
( check
, is
, (~:)
, notWrittenYet
, buildTests
, exp1
, exp2
) where

import Bottom
import Data.Maybe
import Data.Sequence (Seq)
import Id
import Plan.Experiment
import PrelNames
import qualified Data.Sequence as Seq
import Test.HUnit
import TysWiredIn

check :: IO () -> Maybe Test
check = Just . TestCase

notWrittenYet :: Maybe Test
notWrittenYet = Nothing

buildTests :: (Int -> Maybe Test) -> Test
buildTests f = TestList . catMaybes . takeWhile isJust . map f $ [0..]

is :: Maybe Int -> Maybe Int -> IO ()
is = (@?=)

{-
 - exp1 = left (?) right            - Yes these are silly, but they shouldn't be analysed
 - exp2 = (case right True 2) (?)
 -}

leftId  = mkLocalId leftDataConName boolTy
rightId = mkLocalId rightDataConName boolTy
bottom1 = initialBottomId

exp1 = WeakExperiment $ 
  Experiment { experimentRoot = IdRoot leftId
             , experimentArgs = Seq.fromList [ ArgBottom boolTy bottom1
                                             , ArgExperiment $ Experiment { experimentRoot = IdRoot rightId
                                                                          , experimentArgs = Seq.empty
                                                                          , experimentIsProperty = False
                                                                          , experimentHasBottom = False
                                                                          , experimentType = boolTy
                                                                          , experimentMaxDepth = -1
                                                                          , experimentSize     = -1
                                                                          }
                                             ]
             , experimentIsProperty = False
             , experimentHasBottom = True
             , experimentType = boolTy
             , experimentMaxDepth = -1
             , experimentSize     = -1
             }

exp2 = WeakExperiment $
  Experiment { experimentRoot = DestructRoot { destructCaseOf = Experiment { experimentRoot = IdRoot rightId
                                                                           , experimentArgs = Seq.empty
                                                                           , experimentIsProperty = False
                                                                           , experimentHasBottom = False
                                                                           , experimentType = boolTy
                                                                           , experimentMaxDepth = -1
                                                                           , experimentSize     = -1
                                                                           }
                                             , destructConstructor = trueDataCon
                                             , destructVarIndex    = 2
                                             , destructResultType  = boolTy
                                             }
             , experimentArgs = Seq.fromList [ ArgBottom boolTy bottom1 ]
             , experimentIsProperty = False
             , experimentHasBottom = True
             , experimentType = boolTy
             , experimentMaxDepth = -1
             , experimentSize     = -1
             }
