{-# LANGUAGE ExtendedDefaultRules #-}
{-# LANGUAGE TemplateHaskell #-}
module SCA.SimpleTest where

import qualified SCA.TestFunctions as TF
import SCA.SimpleTestLib
import SCA.Simple
import Prelude (($))
import Test.HUnit ((~:))

tests = "SCA.SimpleTest" ~: buildTests test

test 0  = with 'TF.eqZero $ 
           i 0 `elem` lIntConstants

test 1  = with 'TF.forwardPropogate $ 
           noConstants

test 2  = with 'TF.isZeroInt $ do
           [i 0,1] `elem` lIntConstants
           "Forward Propogate" `elem` lStringConstants

test 3  = with 'TF.buildLength $
           [i 0,1] `elem` lIntConstants

test 4  = with 'TF.fib $ do
           [i 0,1,2] `elem` lIntConstants
           "Non-negative fib" `elem` lStringConstants

test 5  = with 'TF.mySum $
           i 0 `elem` lIntConstants

test 6  = with 'TF.filterP $
           i 0 `elem` lIntConstants

test 7  = with 'TF.max $
           noConstants

test 8  = with 'TF.id $
           noConstants

test 9  = with 'TF.twoList $
           "Two List" `elem` lStringConstants

test 10 = with 'TF.isANicePair $ do
            [i 10,0] `elem` lIntConstants
            "Isn't a nice Pair" `elem` lStringConstants

test 11 = with 'TF.mkDoublePair $
            noConstants

test 12 = with 'TF.checkIntViaPair $ do
            i 0 `elem` lIntConstants
            "checkIntViaPair" `elem` lStringConstants

test _ = notWrittenYet
