{-# LANGUAGE PatternGuards #-}
module SCA.TestFunctions where

eqZero :: Int -> Bool
eqZero n = n == 0

forwardPropogate :: Int -> Int
forwardPropogate x = isZeroInt x

isZeroInt :: Int -> Int
isZeroInt 0 = 1
isZeroInt n = error "Forward Propogate"

buildLength :: Int -> [()]
buildLength 0 = []
buildLength n = () : (buildLength (n-1))

fib 0 = 1
fib 1 = 1
fib n | n > 1 = fib (n-1) + fib (n-2)
      | otherwise = error "Non-negative fib"

mySum :: [Int] -> Int
mySum []     = 0
mySum (x:xs) = x + mySum xs

filterP :: [Int] -> [Int]
filterP [] = []
filterP (x:xs)
  | x >= 0    = x : filterP xs
  | otherwise = filterP xs

max :: Int -> Int -> Int
max x y
  | x > y     = x
  | otherwise = y

id :: a -> a
id x = x

twoList :: [Int] -> [Int]
twoList []     = error "Two List"
twoList [x]    = [x]
twoList (x:y:zs)
  | x > y     = twoList ((x+y):zs)
  | otherwise = error "Two List"




data Pair = Pair Int Int

isANicePair :: Pair -> Bool
isANicePair (Pair x y)
  | 10 <- x       = True
  | 0  <- (x - y) = True
  | otherwise     = error "Isn't a nice Pair"

mkDoublePair :: Int -> Pair
mkDoublePair x = Pair x x

checkIntViaPair :: Int -> Bool
checkIntViaPair x
  | x > 0     = isANicePair (mkDoublePair x)
  | x == 0    = False
  | otherwise = error "checkIntViaPair"
