module Tests where

import qualified Engine.ExperimentCacheTests as ECT
import qualified Engine.NewtypeStableNameTests as NSNT
import qualified GHC.Unify as GU
import qualified IdDB.IdDBTest as IIT
import qualified IdDB.TypeMapTest as ITMT
import qualified IdDB.ConstructorGraphTest as ICGT
import qualified Plan.PlanTest as PT
import qualified Plan.ExperimentMapTest as PEMT
import qualified Util.Compose as UC
import qualified Util.GraphTest as GT
import qualified SCA.SimpleTest as SS

import Test.HUnit
import Control.Monad.Reader
import Data.List

allTests = test [ GT.tests
                , ECT.tests
                , NSNT.tests
                , PT.tests
                , UC.tests
                , GU.tests
                , ITMT.tests
                , IIT.tests
                , ICGT.tests
                , SS.tests
                , PEMT.tests
                ]

runTests :: IO ()
runTests = do
  runTestTT allTests
  return ()

select :: Test -> [Int] -> Test
select = foldl' selectOne 
  where
    selectOne :: Test -> Int -> Test
    selectOne (TestCase assertion) = fail "Got assertion, expected test!"
    selectOne (TestList tests)     = asks (tests !!)
    selectOne (TestLabel _ t)      = selectOne t


runTestsSpecific :: [Int] -> IO ()
runTestsSpecific path = do
  runTestTT (select allTests path)
  return ()
