module Util.Compose where

import Test.HUnit
import Type
import TysPrim
import TysWiredIn
import Util.GHC

tests = "Util.Compose" ~: [ test1
                          , test2
                          ]

{-
s1: b -> Int
s2: a -> b
exp: a -> Int
-}
test1 = "test1" ~: test $ lookupTyVar subst alphaTyVar @=? Just intTy
  where
    s1 = mkTopTvSubst [(betaTyVar, intTy)]
    s2 = mkTopTvSubst [(alphaTyVar, mkTyVarTy betaTyVar)]
    subst = composeTvSubsts s1 s2

{-
s1:   a -> Int
s2:   b -> [a]
exp:  b -> [Int]
-}
test2 = "test2" ~: test $ lookupTyVar subst betaTyVar @=? Just (listTyCon `mkTyConApp` [intTy])
  where
    s1 = mkTopTvSubst [(alphaTyVar, intTy)]
    s2 = mkTopTvSubst [(betaTyVar, listTyCon `mkTyConApp` [mkTyVarTy alphaTyVar])]
    subst = composeTvSubsts s1 s2
